
#ifndef __JATRIS_H_INCLUDED__
#define __JATRIS_H_INCLUDED__

#include "GpBaseClass.h"

const short	xblocks=12;
const short     yblocks=21;
const int	blocksize=10;
const int	width=xblocks*blocksize;
const int	height=yblocks*blocksize;
const short	itemcount=7;
const short     itemrotlen=8;
const short	itemlen=itemrotlen*4;
const short	maxcount=5;
const short	maxcolors=6;
const int	barwidth=8;
const int	barcolor=2;
const int	textcolor1=3;
const int	textcolor2=4;

const int items[]={
                          0,0,   -1,0,  0,-1, -1,-1,     // cube, normal
                          0,0,   -1,0,  0,1,  -1,1,      // rotated 90 degrees
			  0,0,   1,0,   0,1,   1,1,      // rotated 180 degrees
                          0,0,   1,0,   0,-1,  1,-1,     // rotated 270 degrees

                          0,0,   0,-1,  0,-2, 0,-3,      // straight line
                          0,0,  -1,0,  -2,0, -3,0,
                          0,0,   0,1,   0,2,  0,3, 
                          0,0,   1,0,   2,0,  3,0,

			  0,0,   1,0,   0,-1, -1,-1,     // stupid block
                          0,0,   0,-1,  -1,0, -1, 1,
			  0,0,  -1,0,   0,1,  1,1,
                          0,0,   0,1,   1,0,  1,-1,

                          0,0,   -1,0,  0,-1,  1,-1,     // stupid block 2
			  0,0,   0,1,   -1,0,  -1,-1,
			  0,0,   1,0,   0,1,   -1,1,
			  0,0,   0,-1,  1,0,   1,1,

			  0,0,   1,0,   -1,0,  0,-1,     // another one
                          0,0,   0,1,   0,-1,  -1,0,
			  0,0,   0,1,   -1,0,  1,0,
			  0,0,   1,0,   0,-1,  0,1,

			  0,0,   0,-1,  1,-1,  0,1,	// hook one
			  0,0,   -1,0,  -1,-1, 1,0,
			  0,0,   -1,1,  0,1,   0,-1,
			  0,0,   -1,0,  1,0,   1,1,

			  0,0,   0,1,  0,-1,  -1,-1,	// hook two
			  0,0,   1,0, -1,0,   -1,1,
			  0,0,   0,-1,  0,1,  1,1,
			  0,0,   -1,0, 1,0,   1,-1
                        };

const int checks[]={ 
                           -1,1, 0,1, -1,1,  0,1,        // check cube, normal
                           -1,2, 0,2, -1,2,  0,2,        // check, rotated 90 degrees
			   0,2,  1,2,  0,2,  1,2,        // check, rotated 180 degrees
                           0,1,  1,1,  0,1,  1,1,        // check, rotated 270 degrees

                           0,1,  0,1,  0,1,  0,1,
                           0,1, -1,1, -2,1, -3,1,
                           0,4,  0,4,  0,4,  0,4,        // straight line
                           0,1,  1,1,  2,1,  3,1,
 
			   0,1,  -1,0, 1,1,  0,1,	// stupid block one
			   0,1,  -1,2, 0,1, -1,2,
			   0,2,  1,2,  -1,2, 0,2,
			   0,2,  1,1,  0,2,  1,1,

			   -1,1,  0,1, 1,0,  1,0,	// stupid block two
			   -1,1,  0,2, 0,2,  -1,1,
			   -1,2,  0,2, 1,1,  1,1,
			   0,1,   1,2,  0,1,  1,2,

			   -1,1,  0,1,  1,1, 1,1,	// block three
			   -1,1,  0,2,  0,2, -1,1,
			   -1,1,  0,2,  1,1, 1,1,
			   0,2,   1,1,  0,2, 1,1,

			   0,2,   1,0,  1,0, 0,2,	// hook one
			   -1,1,  0,1,  1,1, 1,1,
			   -1,2,  0,2,  0,2, -1,2,
			   -1,1,  0,1,  1,2, 1,2,

			   -1,0,  0,2,  0,2, -1,0,	// hook two
			   -1,2,  0,1,  1,1,  1,1,
			   0,2,   1,2,  1,2,  0,2,
			   -1,1,  0,1,  1,1,  1,1
                         };

class Jatris : public GpBaseClass
{ 
public:
  Jatris();
  ~Jatris();

protected:
  virtual void Paint();
  virtual void KeyUp(int key);
  virtual void KeyDown(int key);

private:
  bool		ingame;
  short		screendata[xblocks][yblocks];
  int		blocks[maxcolors+1];
  int		score;
  short		emptyline;
  int		objectx, objecty;
  int		objectdx;
  short		objecttype;
  short		objectcolor;
  int		objectrotation;
  int		objectrotationd;
  short		objectptr;
  short		checkptr;
  short		curcount;
  bool		fast;
  short		count;


  void gameInit();
  void newObject();
  void playGame();
  void showIntro();
  void drawBars();
  bool drawObject();
  void checkRotation();
  void drawBlocks();
  void checkFull();
  void scrollDown();
  void showScore();
};

#endif 
